import os
from Tkinter import *
import tkSimpleDialog
import tkFileDialog
import tkMessageBox



class CreateResourceDialog(tkSimpleDialog.Dialog):

    def __init__(self,docDefNames,parent):
        self.docDefNames = docDefNames
        tkSimpleDialog.Dialog.__init__(self,parent,"Create Resource options")


    def body(self,master):

        rowCtr = 0
        fileNameFrame = Frame(master,borderwidth=1,relief=RIDGE)
        fileNameFrame.grid(row=rowCtr,column=0,sticky=W+E,ipadx=3,ipady=3)
        Label(fileNameFrame,text="Local File:").grid(sticky=W+N+S)
        self.fileNameEntry = Entry(fileNameFrame)
        self.fileNameEntry.grid(row=0,column=1,sticky=E+N+S)

        fileButton = Button(fileNameFrame,text='Browse',command=self.press_file_button)
        fileButton.grid(row=0,column=3)

        rowCtr = rowCtr + 1

        docDefFrame = Frame(master,borderwidth=1,relief=RIDGE)
        docDefFrame.grid(row=rowCtr,column=0,sticky=W+E,ipadx=3,ipady=3)
        rowCtr = rowCtr + 1
        Label(docDefFrame,text="Document Definition:").grid(row=0,column=0,sticky=W+N)

        self.listbox = Listbox(docDefFrame,exportselection=0)
        self.listbox.grid(row=0,column=1,sticky=E+N)


        self.listbox.insert('end','None')
        for name in self.docDefNames:
            self.listbox.insert('end',name)

        self.listbox.select_set(0)




        self.typeVar = IntVar()
        self.typeVar.set(1)

        docClassFrame = Frame(master,borderwidth=1,relief=RIDGE)
        docClassFrame.grid(row=rowCtr,column=0,sticky=W+E,ipadx=3,ipady=3)
        rowCtr = rowCtr + 1

        Label(docClassFrame,text="Document Class:").grid(row=0,column=0,sticky=W+N)
        Radiobutton(docClassFrame, text="XML Document", variable=self.typeVar, value=1).grid(row=0,column=1,sticky=W+N)
        Radiobutton(docClassFrame, text="XSLT Document", variable=self.typeVar, value=2).grid(row=1,column=1,sticky=W+N)
        Radiobutton(docClassFrame, text="HTML Document", variable=self.typeVar, value=3).grid(row=2,column=1,sticky=W+N)
        Radiobutton(docClassFrame, text="Raw File", variable=self.typeVar, value=4).grid(row=3,column=1,sticky=W+N)
        Label(docClassFrame,text="Internet Media Type").grid(row=4,column=1,sticky=W+N)
        self.entry = Entry(docClassFrame)
        self.entry.grid(row=5,column=1,sticky=W+N)

        aliasFrame = Frame(master,borderwidth=1,relief=RIDGE)
        aliasFrame.grid(row=rowCtr,column=0,sticky=W+E,ipadx=3,ipady=3)

        Label(aliasFrame,text="Alias:").grid(row=0,column=0,sticky=W+N)
        self.alias = Entry(aliasFrame)
        self.alias.grid(row=0,column=1,sticky=W+N)



    filetypes = [("XML Files", "*.xml *.xslt", "XML"),
                 ("All files", "*"),
                 ]

    def press_file_button(self):
        opendialog = tkFileDialog.Open(master=self,
                                       filetypes=self.filetypes)
        try:
            pwd = os.getcwd()
        except os.error:
            pwd = ""


        fileName = opendialog.show(initialdir=pwd, initialfile="")
        self.fileNameEntry.delete(0,END)
        self.fileNameEntry.insert(0,fileName)
        self.fileNameEntry.xview(END)

    def validate(self):
        fileName = self.fileNameEntry.get()
        if len(fileName) > 0:
            if os.path.exists(fileName):
                return 1

            tkMessageBox.showerror("Invalid File Name",
                                   "File: %s does not exists" % fileName,
                                   master=self)
        else:
            tkMessageBox.showerror("Must Enter File Name",
                                   "Please enter a file name",
                                   master=self)
            pass
        return 0
        


    def apply(self):
        fileName = self.fileNameEntry.get()

        items = self.listbox.curselection()
        try:
            items = map(int, items)
        except ValueError: pass

        if items[0] == 0:
            ddName = None
        else:
            ddName = self.listbox.get(items[0])

        type_ = self.typeVar.get()

        otherImt = self.entry.get()

        alias = self.alias.get()

        self.result = (fileName,ddName,type_,otherImt,alias)
        



