import threading, time
import FtServerFactory__POA, FtServerFactory

from Ft.Server import Core
from Ft.Server.Server import FtServerServerException,Error

from Ft.Server.Protocols.CORBA.FtOmniorb import OoRepositoryImp
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil

CorbaUtil.Init()

class FtServerFactoryImp(FtServerFactory__POA.FtServerFactoryIf):


    def __init__(self,propertires,configFileName,coreId):
        self._repos = []
        self._lk = threading.RLock()
        self._configFileName = configFileName
        self._coreId = coreId

    def getRepository(self,userName,password,txTimeout):
        try:
            r = Core.GetRepository(userName,password,configFileName=self._configFileName,coreId = self._coreId)
        except FtServerServerException, e:
            if e.code == Error.INVALID_LOGIN:
                raise ExceptionUtil.LogInvalidLoginException(userName)
            raise
        repo = OoRepositoryImp.RepositoryImp(r,self)
        object = CorbaUtil.ActivateObject(repo)
        repo.resource._xa._tx.leave()

        self._lk.acquire()
        try:
            self._repos.append((repo,time.time()+txTimeout/1000.0))
        finally:
            self._lk.release()

        return object

    def getRepositoryAsAnonymous(self,txTimeout):
        r = Core.GetRepository(configFileName=self._configFileName,coreId = self._coreId)
        repo = OoRepositoryImp.RepositoryImp(r,self)
        object = CorbaUtil.ActivateObject(repo)
        repo.resource._xa._tx.leave()

        self._lk.acquire()
        try:
            self._repos.append((repo,time.time()+txTimeout/1000.0))
        finally:
            self._lk.release()

        return object

    def _unregister(self,repo):
        self._lk.acquire()
        try:
            for r,t in self._repos:
                if r == repo:
                    self._repos.remove((r,t))
        finally:
            self._lk.release()


    def _reap(self):

        self._lk.acquire()
        try:
            for r,t in self._repos:
                if t < time.time():
                    r.txRollback()
        finally:
            self._lk.release()


