
import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil
from Ft.Server.Protocols.CORBA.FtOmniorb import OoResourceImp

class RepositoryImp(FtServerResources__POA.RepositoryIf,OoResourceImp.ResourceImp):


    def __init__(self,repo,factory):
        self._objects = []
        self._factory = factory
        OoResourceImp.ResourceImp.__init__(self,repo,self)


    def txCommit(self):
        self.resource._xa._tx.join()
        try:
            self.resource.txCommit()
            for o in self._objects:
                CorbaUtil.DeactivateObject(o)
        except:
            raise ExceptionUtil.LogUnknownPythonException()
        self._objects = []
        self._factory._unregister(self)
        self._factory = None


    def txRollback(self):
        self.resource._xa._tx.join()
        try:
            self.resource.txRollback()
            for o in self._objects:
                CorbaUtil.DeactivateObject(o)
        except:
            raise ExceptionUtil.LogUnknownPythonException()
        self._objects = []
        self._factory._unregister(self)
        self._factory = None

        
    def _registerResource(self,res):
        self._objects.append(res)


